//
// Case-based reasoner
//
//
// TODO REDO THIS FILE

#ifndef CBR_H
#define CBR_H

#include "sqlite3.h"
//#define CBR_LEN_FILENAME 64

#define DATABASENAME "cactus_cbr"

typedef struct cbr_s * cbr;

const char * ops_str[] = {
    "==", "!=", ">", ">=", "<", "<="};

// create the CBR
cbr cbr_create(char * _filename, char * _tablename, char * _cols[], unsigned int _len);

// free the CBR
void cbr_free(cbr _cbr);

// print databse/table
void cbr_print(cbr _cbr);

#define EQ 0    // equals
#define NE 1    // not equals
#define GT 2    // greater than
#define GE 3    // greater than or equal to
#define LT 4    // less than
#define LE 5    // less than or equal to
int cbr_search(cbr _cbr, char *_names[], int * _ops, float *_vals, unsigned int _n, float *_retvals);

int cbr_add_row(cbr _cbr, char *_cols[], float *_vals, unsigned int _len);

struct cbr_s {
    char filename[64];
    char tablename[64];
    char command[2048];
    sqlite3 *db; 
    unsigned int num_columns;
};


// open a database or create a database if it does not exist
int OpenDatabase(cbr _cbr);


// simple callback function, display result
int callback(void *notUsed, int argc, char **argv, char **azColName);


// execute command
int ExecuteCommand(cbr _cbr);


// execute search command
int ExecuteSearchCommand(cbr _cbr, float *_retvals);


// create database
cbr cbr_create(char * _filename, char * _tablename, char * _cols[], unsigned int _len);


// free space
void cbr_free(cbr _cbr);


// print 
void cbr_print(cbr _cbr);


// cbr search
int cbr_search(
    cbr _cbr,
    char *_names[],
    int * _ops,
    float *_vals,
    unsigned int _n,
    float *_retvals);


// update a row 
int cbr_update(cbr _cbr, char *_where[], char*_set[], float *_wherevals, float *_setvals, 
		unsigned int _wherelen, unsigned int _setlen);

// cbr add a row
int cbr_add_row(cbr _cbr, char *_cols[], float *_vals, unsigned int _len);

#endif
